package br.usp.nds.agualastro.integracao;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.InputStreamReader;
import java.nio.ByteBuffer;
import java.util.LinkedList;
import java.util.List;
import java.util.Properties;

import javax.mail.Flags;
import javax.mail.Flags.Flag;
import javax.mail.Folder;
import javax.mail.Message;
import javax.mail.Session;
import javax.mail.Store;
import javax.mail.internet.InternetAddress;
import javax.mail.search.FlagTerm;
import javax.xml.bind.DatatypeConverter;

public class Carregador {

	public static void main(String[] args) throws Exception {
		Properties properties = System.getProperties();
		properties.setProperty("mail.store.protocol", "imaps");
		Session session = Session.getDefaultInstance(properties, null);
		Store store = session.getStore("imaps");
		store.connect("imap.gmail.com", "gnmdmonitoring@gmail.com", "g*s%k3Gskd@skv5H");
		Folder folder = store.getFolder("INBOX");
		folder.open(Folder.READ_WRITE);
		List<Mensagem> mensagens = new LinkedList<Mensagem>();
		for (Message message : folder.search(new FlagTerm(new Flags(Flag.SEEN), true))) {
			if (message.getFrom() != null && message.getFrom().length > 0 && message.getFrom()[0].toString() != null/* && message.getFrom()[0].toString().endsWith("orbcomm.net")*/) {
				ByteArrayOutputStream baos = new ByteArrayOutputStream();
				message.writeTo(baos);
				BufferedReader reader = new BufferedReader(new InputStreamReader(new ByteArrayInputStream(baos.toByteArray())));
				boolean processar1 = false, processar2 = false;
				String codigo = "";
				for (String line = reader.readLine(); line != null; line = reader.readLine()) {
					if (processar2) {
						codigo += line;
						break;
					}
					if (line.startsWith("Content-Transfer")) {
						processar1 = true;
					}
					if (line.isEmpty() && processar1) {
						processar2 = true;
					}
				}
				reader.close();
				byte[] bs = DatatypeConverter.parseBase64Binary(codigo);
				for (int i = 0; i < 2; i++) {
					int numSensores = (bs.length / 2 - 14) / 2;
					int[] sensores = new int[numSensores];
					for (int j = 0; j < sensores.length; j++) {
						sensores[j] = ByteBuffer.wrap(new byte[] {0, 0, bs[j * 2 + 1 + i * bs.length / 2], bs[j * 2 + i * bs.length / 2]}).asIntBuffer().get(0); 
					}
					float latitude = ByteBuffer.wrap(new byte[] {bs[bs.length / 2 - 11 + i * bs.length / 2], bs[bs.length / 2 - 12 + i * bs.length / 2], bs[bs.length / 2 - 13 + i * bs.length / 2], bs[bs.length / 2 - 14 + i * bs.length / 2]}).asFloatBuffer().get(0);
					float longitude = ByteBuffer.wrap(new byte[] {bs[bs.length / 2 - 7 + i * bs.length / 2], bs[bs.length / 2 - 8 + i * bs.length / 2], bs[bs.length / 2 - 9 + i * bs.length / 2], bs[bs.length / 2 - 10 + i * bs.length / 2]}).asFloatBuffer().get(0);
					byte[] instante = {
						(byte)((bs[bs.length / 2 - 6 + i * bs.length / 2] & 0xF) + (((int)bs[bs.length / 2 - 6 + i * bs.length / 2] & 0xF0) >> 4) * 10),
						(byte)((bs[bs.length / 2 - 5 + i * bs.length / 2] & 0xF) + (((int)bs[bs.length / 2 - 5 + i * bs.length / 2] & 0xF0) >> 4) * 10),
						(byte)((bs[bs.length / 2 - 4 + i * bs.length / 2] & 0xF) + (((int)bs[bs.length / 2 - 4 + i * bs.length / 2] & 0xF0) >> 4) * 10),
						(byte)((bs[bs.length / 2 - 3 + i * bs.length / 2] & 0xF) + (((int)bs[bs.length / 2 - 3 + i * bs.length / 2] & 0xF0) >> 4) * 10),
						(byte)((bs[bs.length / 2 - 2 + i * bs.length / 2] & 0xF) + (((int)bs[bs.length / 2 - 2 + i * bs.length / 2] & 0xF0) >> 4) * 10),
						(byte)((bs[bs.length / 2 - 1 + i * bs.length / 2] & 0xF) + (((int)bs[bs.length / 2 - 1 + i * bs.length / 2] & 0xF0) >> 4) * 10)
					};	
					System.out.println(" " + String.format("%02d", instante[5]) + "-" + String.format("%02d", instante[4]) + "-" + String.format("%02d", instante[3]) + " " + String.format("%02d", instante[2]) + ":" + String.format("%02d", instante[1]) + ":" + String.format("%02d", instante[0]));
				}
			}
		}
	}
	
	public List<Mensagem> carregar() throws Exception {
		Properties properties = System.getProperties();
		properties.setProperty("mail.store.protocol", "imaps");
		Session session = Session.getDefaultInstance(properties, null);
		Store store = session.getStore("imaps");
		store.connect("imap.gmail.com", "gnmdmonitoring@gmail.com", "g*s%k3Gskd@skv5H");
		Folder folder = store.getFolder("INBOX");
		folder.open(Folder.READ_WRITE);
		List<Mensagem> mensagens = new LinkedList<Mensagem>();
		for (Message message : folder.search(new FlagTerm(new Flags(Flag.SEEN), false))) {
			if (message.getFrom() != null && message.getFrom().length > 0 && message.getFrom()[0].toString() != null/* && message.getFrom()[0].toString().endsWith("orbcomm.net")*/) {
				ByteArrayOutputStream baos = new ByteArrayOutputStream();
				message.writeTo(baos);
				BufferedReader reader = new BufferedReader(new InputStreamReader(new ByteArrayInputStream(baos.toByteArray())));
				boolean processar1 = false, processar2 = false;
				String codigo = "";
				for (String line = reader.readLine(); line != null; line = reader.readLine()) {
					System.out.println("msg >>>" + line);
					if (processar2) {
						codigo += line;
						break;
					}
					if (line.startsWith("Content-Transfer")) {
						processar1 = true;
					}
					if (line.isEmpty() && processar1) {
						processar2 = true;
					}
				}
				reader.close();
				System.out.println("codigo = " + codigo);
				byte[] bs = DatatypeConverter.parseBase64Binary(codigo);
				System.out.println("tamanho = " + bs.length);
				for (int i = 0; i < 2; i++) {
					int numSensores = (bs.length / 2 - 14) / 2;
					int[] sensores = new int[numSensores];
					for (int j = 0; j < sensores.length; j++) {
						sensores[j] = ByteBuffer.wrap(new byte[] {0, 0, bs[j * 2 + 1 + i * bs.length / 2], bs[j * 2 + i * bs.length / 2]}).asIntBuffer().get(0); 
					}
					float latitude = ByteBuffer.wrap(new byte[] {bs[bs.length / 2 - 11 + i * bs.length / 2], bs[bs.length / 2 - 12 + i * bs.length / 2], bs[bs.length / 2 - 13 + i * bs.length / 2], bs[bs.length / 2 - 14 + i * bs.length / 2]}).asFloatBuffer().get(0);
					float longitude = ByteBuffer.wrap(new byte[] {bs[bs.length / 2 - 7 + i * bs.length / 2], bs[bs.length / 2 - 8 + i * bs.length / 2], bs[bs.length / 2 - 9 + i * bs.length / 2], bs[bs.length / 2 - 10 + i * bs.length / 2]}).asFloatBuffer().get(0);
					byte[] instante = {
						(byte)((bs[bs.length / 2 - 6 + i * bs.length / 2] & 0xF) + (((int)bs[bs.length / 2 - 6 + i * bs.length / 2] & 0xF0) >> 4) * 10),
						(byte)((bs[bs.length / 2 - 5 + i * bs.length / 2] & 0xF) + (((int)bs[bs.length / 2 - 5 + i * bs.length / 2] & 0xF0) >> 4) * 10),
						(byte)((bs[bs.length / 2 - 4 + i * bs.length / 2] & 0xF) + (((int)bs[bs.length / 2 - 4 + i * bs.length / 2] & 0xF0) >> 4) * 10),
						(byte)((bs[bs.length / 2 - 3 + i * bs.length / 2] & 0xF) + (((int)bs[bs.length / 2 - 3 + i * bs.length / 2] & 0xF0) >> 4) * 10),
						(byte)((bs[bs.length / 2 - 2 + i * bs.length / 2] & 0xF) + (((int)bs[bs.length / 2 - 2 + i * bs.length / 2] & 0xF0) >> 4) * 10),
						(byte)((bs[bs.length / 2 - 1 + i * bs.length / 2] & 0xF) + (((int)bs[bs.length / 2 - 1 + i * bs.length / 2] & 0xF0) >> 4) * 10)
					};
					Mensagem mensagem = new Mensagem(sensores, latitude, longitude, instante, ((InternetAddress)message.getFrom()[0]).getAddress()); 
					mensagens.add(mensagem);	
					System.out.println("mensagem = " + mensagem);
				}
			}
			message.setFlag(Flag.SEEN, true);
		}
		return mensagens;
	}
}
